Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QImageReader

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.gui.QImageReader

All Implemented Interfaces:
  QtJambiInterface

    public class QImageReader

extends QtJambiObject

The `QImageReader` class provides a format independent interface for reading images from files or other devices. The most common way to read images is through `QImage` and `QPixmap`'s constructors, or by calling `QImage::load()` and `QPixmap::load()`. `QImageReader` is a specialized class which gives you more control when reading images. For example, you can read an image into a specific size by calling `setScaledSize()`, and you can select a clip rect, effectively loading only parts of an image, by calling `setClipRect()`. Depending on the underlying support in the image format, this can save memory and speed up loading of images.

To read an image, you start by constructing a `QImageReader` object. Pass either a file name or a device pointer, and the image format to `QImageReader`'s constructor. You can then set several options, such as the clip rect (by calling `setClipRect()`) and scaled size (by calling `setScaledSize()`). `canRead()` returns the image if the `QImageReader` can read the image (i.e., the image format is supported and the device is open for reading). Call `read()` to read the image.

If any error occurs when reading the image, `read()` will return a null `QImage`. You can then call `error()` to find the type of error that occurred, or `errorString()` to get a human readable description of what went wrong.

Call `supportedImageFormats()` for a list of formats that `QImageReader` can read. `QImageReader` supports all built-in image formats, in addition to any image format plugins that support reading.

See also:
  `QImageWriter`, `QImageIOHandler`, and `QImageIOPlugin`.

Nested Class Summary
`static class` | `QImageReader.ImageReaderError` This enum describes the different types of errors that can occur when reading images with `QImageReader`.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QImageReader()` Constructs an empty `QImageReader` object.
`QImageReader(QIODevice device)` Constructs a `QImageReader` object with the device `device` and the image format `format`.
`QImageReader(QIODevice device, QByteArray format)` Constructs a `QImageReader` object with the device `device` and the image format `format`.
`QImageReader(java.lang.String fileName)` Constructs a `QImageReader` object with the file name `fileName` and the image format `format`.
`QImageReader(java.lang.String fileName, QByteArray format)` Constructs a `QImageReader` object with the file name `fileName` and the image format `format`.

Method Summary
`QColor` | `backgroundColor()` Returns the background color that's used when reading an image.
`boolean` | `canRead()` Returns true if an image can be read for the device (i.
`QRect` | `clipRect()` Returns the clip rect (also known as the ROI, or Region Of Interest) of the image.
`int` | `currentImageNumber()` For image formats that support animation, this function returns the sequence number of the current frame.
`QRect` | `currentImageRect()` For image formats that support animation, this function returns the rect for the current frame.
`QIODevice` | `device()` Returns the device currently assigned to `QImageReader`, or 0 if no device has been assigned.
`QImageReader.ImageReaderError` | `error()` Returns the type of error that occurred last.
`java.lang.String` | `errorString()` Returns a human readable description of the last error that occurred.
`java.lang.String` | `fileName()` If the currently assigned device is a `QFile`, or if `setFileName()` has been called, this function returns the name of the file `QImageReader` reads from.
`QByteArray` | `format()` Returns the format `QImageReader` uses for reading images.
`int` | `imageCount()` For image formats that support animation, this function returns the total number of images in the animation.
`static QByteArray` | `imageFormat(QIODevice device)` If supported, this function returns the image format of the device `device`.
`static QByteArray` | `imageFormat(java.lang.String fileName)` If supported, this function returns the image format of the file `fileName`.
`boolean` | `jumpToImage(int imageNumber)` For image formats that support animation, this function skips to the image whose sequence number is `imageNumber`, returning true if successful or false if the corresponding image cannot be found.
`boolean` | `jumpToNextImage()` For image formats that support animation, this function steps over the current image, returning true if successful or false if there is no following image in the animation.
`int` | `loopCount()` For image formats that support animation, this function returns the number of times the animation should loop.
`int` | `nextImageDelay()` For image formats that support animation, this function returns the number of milliseconds to wait until displaying the next frame in the animation.
`int` | `quality()` Returns the quality level of the image.
`QImage` | `read()` Reads an image from the device.
`QRect` | `scaledClipRect()` Returns the scaled clip rect of the image.
`QSize` | `scaledSize()` Returns the scaled size of the image.
`void` | `setBackgroundColor(QColor color)` Sets the background color to `color`.
`void` | `setClipRect(QRect rect)` Sets the image clip rect (also known as the ROI, or Region Of Interest) to `rect`.
`void` | `setDevice(QIODevice device)` Sets `QImageReader`'s device to `device`.
`void` | `setFileName(java.lang.String fileName)` Sets the file name of `QImageReader` to `fileName`.
`void` | `setFormat(QByteArray format)` Sets the format `QImageReader` will use when reading images, to `format`.
`void` | `setQuality(int quality)` This is an image format specific function that sets the quality level of the image to `quality`.
`void` | `setScaledClipRect(QRect rect)` Sets the scaled clip rect to `rect`.
`void` | `setScaledSize(QSize size)` Sets the scaled size of the image to `size`.
`QSize` | `size()` Returns the size of the image, without actually reading the image contents.
`static java.util.List` | `supportedImageFormats()` Returns the list of image formats supported by `QImageReader`.
`boolean` | `supportsAnimation()` Returns true if the image format supports animation; otherwise, false is returned.
`boolean` | `supportsOption(QImageIOHandler.ImageOption option)` Returns true if the reader supports `option`; otherwise returns false.
`java.lang.String` | `text(java.lang.String key)` Returns the image text associated with `key`.
`java.util.List` | `textKeys()` Returns the text keys for this image.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QImageReader

    public QImageReader()

  Constructs an empty `QImageReader` object. Before reading an image, call `setDevice()` or `setFileName()`.

### QImageReader

    public QImageReader(QIODevice device)

  Constructs a `QImageReader` object with the device `device` and the image format `format`.

### QImageReader

    public QImageReader(QIODevice device,
                        QByteArray format)

  Constructs a `QImageReader` object with the device `device` and the image format `format`.

### QImageReader

    public QImageReader(java.lang.String fileName)

  Constructs a `QImageReader` object with the file name `fileName` and the image format `format`.

See also:
  `setFileName()`.

### QImageReader

    public QImageReader(java.lang.String fileName,
                        QByteArray format)

  Constructs a `QImageReader` object with the file name `fileName` and the image format `format`.

See also:
  `setFileName()`.

Method Detail

### backgroundColor

    public final QColor backgroundColor()

  Returns the background color that's used when reading an image. If the image format does not support setting the background color an invalid color is returned.

See also:
  `setBackgroundColor()`, and `read()`.

### canRead

    public final boolean canRead()

  Returns true if an image can be read for the device (i. ., the image format is supported, and the device seems to contain valid data); otherwise returns false.

  `canRead()` is a lightweight function that only does a quick test to see if the image data is valid. `read()` may still return false after `canRead()` returns true, if the image data is corrupt.

  For images that support animation, `canRead()` returns false when all frames have been read.

See also:
  `read()`, and `supportedImageFormats()`.

### clipRect

    public final QRect clipRect()

  Returns the clip rect (also known as the ROI, or Region Of Interest) of the image. If no clip rect has been set, an invalid `QRect` is returned.

See also:
  `setClipRect()`.

### currentImageNumber

    public final int currentImageNumber()

  For image formats that support animation, this function returns the sequence number of the current frame. Otherwise, -1 is returned.

See also:
  `supportsAnimation()`, and `QImageIOHandler::currentImageNumber()`.

### currentImageRect

    public final QRect currentImageRect()

  For image formats that support animation, this function returns the rect for the current frame. Otherwise, a null rect is returned.

See also:
  `supportsAnimation()`, and `QImageIOHandler::currentImageRect()`.

### device

    public final QIODevice device()

  Returns the device currently assigned to `QImageReader`, or 0 if no device has been assigned.

See also:
  `setDevice()`.

### error

    public final QImageReader.ImageReaderError error()

  Returns the type of error that occurred last.

See also:
  `ImageReaderError` , and `errorString()`.

### errorString

    public final java.lang.String errorString()

  Returns a human readable description of the last error that occurred.

See also:
  `error()`.

### fileName

    public final java.lang.String fileName()

  If the currently assigned device is a `QFile`, or if `setFileName()` has been called, this function returns the name of the file `QImageReader` reads from. Otherwise (i.e., if no device has been assigned or the device is not a `QFile`), an empty QString is returned.

See also:
  `setFileName()`, and `setDevice()`.

### format

    public final QByteArray format()

  Returns the format `QImageReader` uses for reading images.

  You can call this function after assigning a device to the reader to determine the format of the device. For example:

              QImageReader reader = new QImageReader("image.png");
              // reader.format() == "png"

  If the reader cannot read any image from the device (e.g., there is no image there, or the image has already been read), or if the format is unsupported, this function returns an empty QByteArray().

See also:
  `setFormat()`, and `supportedImageFormats()`.

### imageCount

    public final int imageCount()

  For image formats that support animation, this function returns the total number of images in the animation.

  Certain animation formats do not support this feature, in which case 0 is returned.

See also:
  `supportsAnimation()`, and `QImageIOHandler::imageCount()`.

### jumpToImage

    public final boolean jumpToImage(int imageNumber)

  For image formats that support animation, this function skips to the image whose sequence number is `imageNumber`, returning true if successful or false if the corresponding image cannot be found.

  The next call to `read()` will attempt to read this image.

See also:
  `jumpToNextImage()`, and `QImageIOHandler::jumpToImage()`.

### jumpToNextImage

    public final boolean jumpToNextImage()

  For image formats that support animation, this function steps over the current image, returning true if successful or false if there is no following image in the animation.

  The default implementation calls `read()`, then discards the resulting image, but the image handler may have a more efficient way of implementing this operation.

See also:
  `jumpToImage()`, and `QImageIOHandler::jumpToNextImage()`.

### loopCount

    public final int loopCount()

  For image formats that support animation, this function returns the number of times the animation should loop. Otherwise, it returns -1.

See also:
  `supportsAnimation()`, and `QImageIOHandler::loopCount()`.

### nextImageDelay

    public final int nextImageDelay()

  For image formats that support animation, this function returns the number of milliseconds to wait until displaying the next frame in the animation. Otherwise, 0 is returned.

See also:
  `supportsAnimation()`, and `QImageIOHandler::nextImageDelay()`.

### quality

    public final int quality()

  Returns the quality level of the image.

See also:
  `setQuality()`.

### read

    public final QImage read()

  Reads an image from the device. On success, the image that was read is returned; otherwise, a null `QImage` is returned. You can then call `error()` to find the type of error that occurred, or `errorString()` to get a human readable description of the error.

  For image formats that support animation, calling `read()` repeatedly will return the next frame. When all frames have been read, a null image will be returned.

See also:
  `canRead()`, `supportedImageFormats()`, `supportsAnimation()`, and `QMovie`.

### scaledClipRect

    public final QRect scaledClipRect()

  Returns the scaled clip rect of the image.

See also:
  `setScaledClipRect()`.

### scaledSize

    public final QSize scaledSize()

  Returns the scaled size of the image.

See also:
  `setScaledSize()`.

### setBackgroundColor

    public final void setBackgroundColor(QColor color)

  Sets the background color to `color`. Image formats that support this operation are expected to initialize the background to `color` before reading an image.

See also:
  `backgroundColor()`, and `read()`.

### setClipRect

    public final void setClipRect(QRect rect)

  Sets the image clip rect (also known as the ROI, or Region Of Interest) to `rect`. The coordinates of `rect` are relative to the untransformed image size, as returned by `size()`.

See also:
  `clipRect()`, `setScaledSize()`, and `setScaledClipRect()`.

### setDevice

    public final void setDevice(QIODevice device)

  Sets `QImageReader`'s device to `device`. If a device has already been set, the old device is removed from `QImageReader` and is otherwise left unchanged.

  If the device is not already open, `QImageReader` will attempt to open the device in `QIODevice::ReadOnly` mode by calling open(). Note that this does not work for certain devices, such as `QProcess`, `QTcpSocket` and `QUdpSocket`, where more logic is required to open the device.

See also:
  `device()`, and `setFileName()`.

### setFileName

    public final void setFileName(java.lang.String fileName)

  Sets the file name of `QImageReader` to `fileName`. Internally, `QImageReader` will create a `QFile` object and open it in `QIODevice::ReadOnly` mode, and use this when reading images.

  If `fileName` does not include a file extension (e.g., .png or .bmp), `QImageReader` will cycle through all supported extensions until it finds a matching file.

See also:
  `fileName()`, `setDevice()`, and `supportedImageFormats()`.

### setFormat

    public final void setFormat(QByteArray format)

  Sets the format `QImageReader` will use when reading images, to `format`. `format` is a case insensitive text string. Example:

              QImageReader reader = new QImageReader();
              reader.setFormat(new QByteArray("png")); // same as reader.setFormat("PNG");

  You can call `supportedImageFormats()` for the full list of formats `QImageReader` supports.

See also:
  `format()`.

### setQuality

    public final void setQuality(int quality)

  This is an image format specific function that sets the quality level of the image to `quality`. For image formats that do not support setting the quality, this value is ignored.

  The value range of `quality` depends on the image format. For example, the "jpeg" format supports a quality range from 0 (low quality, high compression) to 100 (high quality, low compression).

See also:
  `quality()`.

### setScaledClipRect

    public final void setScaledClipRect(QRect rect)

  Sets the scaled clip rect to `rect`. The scaled clip rect is the clip rect (also known as ROI, or Region Of Interest) that is applied after the image has been scaled.

See also:
  `scaledClipRect()`, and `setScaledSize()`.

### setScaledSize

    public final void setScaledSize(QSize size)

  Sets the scaled size of the image to `size`. The scaling is performed after the initial clip rect, but before the scaled clip rect is applied. The algorithm used for scaling depends on the image format. By default (i.e., if the image format does not support scaling), `QImageReader` will use QImage::scale() with Qt::SmoothScaling.

See also:
  `scaledSize()`, `setClipRect()`, and `setScaledClipRect()`.

### size

    public final QSize size()

  Returns the size of the image, without actually reading the image contents.

  If the image format does not support this feature, this function returns an invalid size. Qt's built-in image handlers all support this feature, but custom image format plugins are not required to do so.

See also:
  `QImageIOHandler::ImageOption` , `QImageIOHandler::option()`, and `QImageIOHandler::supportsOption()`.

### supportsAnimation

    public final boolean supportsAnimation()

  Returns true if the image format supports animation; otherwise, false is returned.

See also:
  `QMovie::supportedFormats()`.

### supportsOption

    public final boolean supportsOption(QImageIOHandler.ImageOption option)

  Returns true if the reader supports `option`; otherwise returns false.

  Different image formats support different options. Call this function to determine whether a certain option is supported by the current format. For example, the PNG format allows you to embed text into the image's metadata (see `text()`), and the BMP format allows you to determine the image's size without loading the whole image into memory (see `size()`).

              QImageReader reader = new QImageReader("classpath:/image.png");
              if (reader.supportsOption(QImageIOHandler.ImageOption.Size))
                  System.err.println("Size: " + reader.size());

See also:
  `QImageWriter::supportsOption()`.

### text

    public final java.lang.String text(java.lang.String key)

  Returns the image text associated with `key`.

  Support for this option is implemented through `QImageIOHandler::Description` .

See also:
  `textKeys()`, and `QImageWriter::setText()`.

### textKeys

    public final java.util.List textKeys()

  Returns the text keys for this image. You can use these keys with `text()` to list the image text for a certain key.

  Support for this option is implemented through `QImageIOHandler::Description` .

See also:
  `text()`, `QImageWriter::setText()`, and `QImage::textKeys()`.

### imageFormat

    public static QByteArray imageFormat(QIODevice device)

  If supported, this function returns the image format of the device `device`. Otherwise, an empty string is returned.

### imageFormat

    public static QByteArray imageFormat(java.lang.String fileName)

  If supported, this function returns the image format of the file `fileName`. Otherwise, an empty string is returned.

### supportedImageFormats

    public static java.util.List supportedImageFormats()

  Returns the list of image formats supported by `QImageReader`.

  By default, Qt can read the following formats:

  Format | Description
  --- | ---
  BMP | Windows Bitmap
  GIF | Graphic Interchange Format (optional)
  JPG | Joint Photographic Experts Group
  JPEG | Joint Photographic Experts Group
  MNG | Multiple-image Network Graphics
  PNG | Portable Network Graphics
  PBM | Portable Bitmap
  PGM | Portable Graymap
  PPM | Portable Pixmap
  TIFF | Tagged Image File Format
  XBM | X11 Bitmap
  XPM | X11 Pixmap

  Reading and writing SVG files is supported through Qt's SVG Module.

  To configure Qt with GIF support, pass `-qt-gif` to the `configure` script or check the appropriate option in the graphical installer.

See also:
  `setFormat()`, `QImageWriter::supportedImageFormats()`, and `QImageIOPlugin`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD